//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <iterator>
#include <list>
#include <algorithm>

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;


std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main(int argc, char* argv[])
{
  list<int> coll;

  //    1  9 
  for (int i=1; i<=9; ++i) {
    coll.push_back(i); 
  }

  //      5 
  list<int>::iterator pos;
  pos = find (coll.begin(), coll.end(),  // 
               5); // 

  //   
  cout << ToRus("  pos: ") << *pos << endl;

  //      
  list<int>::reverse_iterator rpos(pos);

  //   ,      
  cout << ToRus(" ,      rpos:" )
       << *rpos << endl;

  //      
  list<int>::iterator rrpos; 
  rrpos = rpos.base();

 //   ,     
  cout << ToRus(" ,     rrpos: ") 
       << *rrpos << endl;

  getch();
  return 0;
}

//---------------------------------------------------------------------------